script_author('vespan')
script_version('1.0.1')
script_name('[arz]  ')
script_url('blast.hk/threads/150355/')

require 'moonloader'
encoding = require("encoding"); encoding.default = 'CP1251'; u8 = encoding.UTF8  
sampev = require'samp.events'
imgui = require 'imgui'

function json(filePath)
if not doesDirectoryExist((filePath:match('(.+)/.+%.%S+'))) then return end
    local class = {}
        function class.save(tbl)
        if tbl then local F = io.open(filePath, 'w');	F:write(encodeJson(tbl) or {});	F:close();	return true, 'ok' end
        return false, 'table = nil'
    end
    function class.load(defaultTable)
        if not doesFileExist(filePath) then;	class.save(defaultTable or {});	end
        local F = io.open(filePath, 'r+')
        local TABLE = decodeJson(F:read() or {}); F:close()
        for def_k, def_v in next, defaultTable do;	if TABLE[def_k] == nil then;	TABLE[def_k] = def_v;	end
        end
        return TABLE
    end; return class
end

jsonDirect = 'moonloader/config/[arz]timer auto salon.json'
j = json(jsonDirect).load({
	window = {
		x = 300,
		y = 500,
	},
	veh = {}
})

window = imgui.ImBool(false)

function main()
	while not isSampAvailable() do wait(0) end
	if #j.veh ~= 0 then
		window.v = true
	end
	sampRegisterChatCommand('tas',function()
		window.v = not window.v
	end)
	while true do wait(0)
		imgui.Process = window.v
	end
end

function imgui.OnDrawFrame()
	local sw,sh = getScreenResolution()

	if window.v then
		imgui.ShowCursor = false
		imgui.SetNextWindowPos(imgui.ImVec2(j['window']['x'],j['window']['y']), imgui.Cond.FirstUseEver)
		imgui.Begin('_',window,1+2+64)
		local wx,wy = imgui.GetWindowPos().x,imgui.GetWindowPos().y
		if j['window']['x'] ~= wx or j['window']['y'] ~= wy then
			j['window']['x'],j['window']['y'] = wx,wy
			json(jsonDirect).save(j)
		end
		if #j.veh ~= 0 then
			for k,TABLE in pairs(j.veh) do
				imgui.Text(string.format('%s %s',j.veh[k].car,convertTime(j.veh[k].time-(os.time()-j.veh[k].timer)) ))
				if imgui.IsItemClicked(1) then
					imgui.OpenPopup('info '..k)
				end

				if imgui.BeginPopup('info '..k) then
					imgui.Text(u8(string.format(' %s\n %s\n %s',j.veh[k].salon,j.veh[k].car,j.veh[k].buying) ))
					if imgui.Button(u8'') then
						table.remove(j.veh,k)
						json(jsonDirect).save(j)
					end
				imgui.EndPopup()
				end

			end
		else
			imgui.Text(u8(''))
			if imgui.Button(u8' ') then window.v = false end
		end

		imgui.End()
	end
end

function sampev.onShowDialog(id, style, title, b1, b2, text) 
	if style == 0 and title:find('') and text:find('%{ffffff%}  %: %{FA5858%}%S+') then
--[[
{ffffff}       {FA5858}Bullet
{ffffff}  : {FA5858}04:38:54
{ffffff} : {FA5858}$10200000
]]
		local salon = title:match(' (.+)')
		local car = ''
		for l in text:gmatch('[^\n]+') do
			if l:find('%{ffffff%}      %S+ %{FA5858%}(.+)') then
				car = l:match('%{ffffff%}      %S+ %{FA5858%}(.+)')
			end
		end
		local buying = text:match('%{ffffff%} %S+%: %{FA5858%}(%S+)')
		local time = text:match('%{ffffff%}  %: %{FA5858%}(%S+)')
		local timer = {}
		if time:find('^%d+%:%d+%:%d+$') then
			timer.sec = tonumber(time:match('%d+%:%d+%:(%d+)'))
			timer.min = tonumber(time:match('%d+%:(%d+)%:%d+'))
			timer.hour = tonumber(time:match('(%d+)%:%d+%:%d+'))
			timer.timer = (timer.hour*60*60) + (timer.min*60) + timer.sec
		elseif time:find('^%d+%:%d+$') then
			timer.sec = tonumber(time:match('%d+%:(%d+)'))
			timer.min = tonumber(time:match('(%d+)%:%d+'))
			timer.timer = (timer.min*60) + timer.sec
		elseif time:find('^%d+$') then
			timer.sec = tonumber(time:match('(%d+)'))
			timer.timer = timer.sec
		end
		local ss = {isStringInTable(car,j.veh)}
		if not ss[1] then
			table.insert(j.veh,{salon=salon,car=car,buying=buying,time=os.time(),timer=timer.timer})
			json(jsonDirect).save(j)
		else
			j.veh[ss[2]].timer = timer.timer
			j.veh[ss[2]].time = os.time()
			json(jsonDirect).save(j)
		end
		-- sampAddChatMessage('%s %s %s(%s %s %s > TIMER - %s)',car,buying,timer1,timer.sec,timer.min,timer.hour,timer.timer)
	end
end

function isStringInTable(string,table)
	for k,v in pairs(table) do
		for kk,vv in pairs(v) do
			if vv == string then
				return true,k,kk
			end
		end
	end
	return false,0
end

function convertTime(time)
	local mf = math.floor
	if time > 60 and time < 3600 then
		return string.format('%s:%s',mf((time/60)),mf((time%60)))
	elseif time > 3600 then
		return string.format('%s:%s:%s',mf(time/60/60),mf(time/60%60),mf(time%60))
	elseif time < 0 then
		return u8'!'
	end
	return time
end